"use strict";
{
	const C3 = self.C3;
	const MODE = 0;
	const ENABLED = 1;
	C3.Behaviors.skymen_BoundToViewport.Instance = class BoundToViewportInstance extends C3.SDKBehaviorInstanceBase
	{
		constructor(behInst, properties) {
	      super(behInst);
	      this._mode = 0;
	      if (properties) {
	      	this._mode = properties[MODE];
	      	this.enabled = properties[ENABLED];
	      }
	    }
	    
	    get enabled() {
	    	return this._enabled;
	    }
	    
	    set enabled(val) {
	    	if (this._enabled === !!val) return;
	    	this._enabled = !!val;
	    	if (this._enabled) this._StartTicking2();
	    	else this._StopTicking2();
	    }
	    
	    Release() {
	      super.Release();
	    }
	    SaveToJson() {
	      return { m: this._mode };
	    }
	    LoadFromJson(o) {
	      this._mode = o["m"];
	    }
	    Tick2() {
	      const wi = this._inst.GetWorldInfo();
	      const bbox = wi.GetBoundingBox();
	      const layer = wi.GetLayer();
	      const viewport = layer.GetViewport()
	      let isChanged = false;
	      if (this._mode === 0) {
	        if (wi.GetX() < viewport.getLeft()) {
	          wi.SetX(viewport.getLeft());
	          isChanged = true;
	        }
	        if (wi.GetY() < viewport.getTop()) {
	          wi.SetY(viewport.getTop());
	          isChanged = true;
	        }
	        if (wi.GetX() > viewport.getRight()) {
	          wi.SetX(viewport.getRight());
	          isChanged = true;
	        }
	        if (wi.GetY() > viewport.getBottom()) {
	          wi.SetY(viewport.getBottom());
	          isChanged = true;
	        }
	      } else {
	        if (bbox.getLeft() < viewport.getLeft()) {
	          wi.OffsetX(-(bbox.getLeft() - viewport.getLeft()));
	          isChanged = true;
	        }
	        if (bbox.getTop() < viewport.getTop()) {
	          wi.OffsetY(-(bbox.getTop() - viewport.getTop()));
	          isChanged = true;
	        }
	        if (bbox.getRight() > viewport.getRight()) {
	          wi.OffsetX(-(bbox.getRight() - viewport.getRight()));
	          isChanged = true;
	        }
	        if (bbox.getBottom() > viewport.getBottom()) {
	          wi.OffsetY(-(bbox.getBottom() - viewport.getBottom()));
	          isChanged = true;
	        }
	      }
	      if (isChanged) wi.SetBboxChanged();
	    }
	    GetPropertyValueByIndex(index) {
	      switch (index) {
	        case MODE:
	          return this._mode;
	        case Enable:
	          return this.enabled;
	      }
	    }
	    SetPropertyValueByIndex(index, value) {
	      switch (index) {
	        case MODE:
	          this._mode = value;
	          break;
	        case ENABLED:
	          this.enabled = value;
	          break;
	      }
	    }
	};
}